; User Types
;; a hack to extend the Scheme type system...
;; The scheme implementation provides no weak references,
;; so we simulate the weak reference interface with it;


(provide 'types)

(define (types:make-tag t)
   (make-tag 'types t))

(define types::registered
  '(
    (promise	. ,promise?)
    (input-port . ,input-port?)
    (output-port. ,output-port?)
    (eof-object	. ,eof-object?)
    (null	. ,null?)
    (procedure	. ,procedure?)
    (boolean	. ,boolean?)
    (number	. ,number?)
    (string	. ,string?)
    (symbol	. ,symbol?)
    (vector	. ,vector?)
    (pair	. ,pair?)
    (char	. ,char?)))

(define (types:register name test)
   (set! types::registered (cons (cons name test) types::registered)))

(define (typeof obj)
    (letrec
       ((scan (lambda (l)
	   (if (null? l) (ERROR "Unknown type!" obj))
	   (if ((cdar l) obj) (caar l) (scan (cdr l))))))
       (scan types::registered)))
